.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
LOOP_COUNT	= 1000000

.data
Src1	db "000This is a string", 0	; 3 leading discardable chars
Src2	db " 0This is a string", 0	; 2 chars
Src3	db "0This is a string", 0	; 1 char
Src4	db "This is a string", 0	; none

.code
start:
	push 1
	call ShowCpu
	ct = 0
	REPEAT 4
	ct = ct + 1
	tmp$ CATSTR <push offset Src>, %ct

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpAlInc
	counter_end
	print str$(eax), 9, "cycles for LoopJmpAlInc", 13, 10

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpAlAdd
	counter_end
	print str$(eax), 9, "cycles for LoopJmpAlAdd", 13, 10

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpAlSub
	counter_end
	print str$(eax), 9, "cycles for LoopJmpAlSub", 13, 10

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpZxInc
	counter_end
	print str$(eax), 9, "cycles for LoopJmpZxInc", 13, 10

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpZxAdd
	counter_end
	print str$(eax), 9, "cycles for LoopJmpZxAdd", 13, 10

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpZxSub
	counter_end
	print str$(eax), 9, "cycles for LoopJmpZxSub", 13, 10

	invoke Sleep, 50
	counter_begin LOOP_COUNT, REALTIME_PRIORITY_CLASS
		tmp$
		call LoopJmpLingo
	counter_end
	print str$(eax), 9, "cycles for LoopJmpLingo", 13, 10, 10
	ENDM

	print "Sizes:", 13, 10
	mov eax, LoopJmpAlInc_endp
	sub eax, LoopJmpAlInc_proc
	print str$(eax), 9, "LoopJmpAlInc", 13, 10
	mov eax, LoopJmpAlAdd_endp
	sub eax, LoopJmpAlAdd_proc
	print str$(eax), 9, "LoopJmpAlAdd", 13, 10
	mov eax, LoopJmpAlSub_endp
	sub eax, LoopJmpAlSub_proc
	print str$(eax), 9, "LoopJmpAlSub", 13, 10
	mov eax, LoopJmpZxInc_endp
	sub eax, LoopJmpZxInc_proc
	print str$(eax), 9, "LoopJmpZxInc", 13, 10
	mov eax, LoopJmpZxAdd_endp
	sub eax, LoopJmpZxAdd_proc
	print str$(eax), 9, "LoopJmpZxAdd", 13, 10
	mov eax, LoopJmpZxSub_endp
	sub eax, LoopJmpZxSub_proc
	print str$(eax), 9, "LoopJmpZxSub", 13, 10
	mov eax, LoopJmpLingo_endp
	sub eax, LoopJmpLingo_proc
	print str$(eax), 9, "LoopJmpLingo", 13, 10
	inkey chr$("--- ok ---")
	exit

align 16
LoopJmpAlInc_proc:
LoopJmpAlInc proc
	mov edx, [esp+4]
	jmp L1
@@:	inc edx
L1:	mov al, [edx]
	cmp al, 32
	jle @B
	cmp al, "0"
	je @B
  ret 4
LoopJmpAlInc endp
LoopJmpAlInc_endp:

align 16
LoopJmpAlAdd_proc:
LoopJmpAlAdd proc
	mov edx, [esp+4]
	jmp L1
@@:	add edx, 1
L1:	mov al, [edx]
	cmp al, 32
	jle @B
	cmp al, "0"
	je @B
  ret 4
LoopJmpAlAdd endp
LoopJmpAlAdd_endp:

align 16
LoopJmpAlSub_proc:
LoopJmpAlSub proc
	mov edx, [esp+4]
	jmp L1
@@:	sub edx, -1
L1:	mov al, [edx]
	cmp al, 32
	jle @B
	cmp al, "0"
	je @B
  ret 4
LoopJmpAlSub endp
LoopJmpAlSub_endp:

align 16
LoopJmpZxInc_proc:
LoopJmpZxInc proc
	mov edx, [esp+4]
	jmp L1
@@:	inc edx
L1:	movzx eax, byte ptr [edx]
	cmp al, 32
	jle @B
	cmp al, "0"
	je @B
  ret 4
LoopJmpZxInc endp
LoopJmpZxInc_endp:

align 16
LoopJmpZxAdd_proc:
LoopJmpZxAdd proc
	mov edx, [esp+4]
	jmp L1
@@:	add edx, 1
L1:	movzx eax, byte ptr [edx]
	cmp al, 32
	jle @B
	cmp al, "0"
	je @B
  ret 4
LoopJmpZxAdd endp
LoopJmpZxAdd_endp:

align 16
LoopJmpZxSub_proc:
LoopJmpZxSub proc
	mov edx, [esp+4]
	jmp L1
@@:	sub edx, -1
L1:	movzx eax, byte ptr [edx]
	cmp al, 32
	jle @B
	cmp al, "0"
	je @B
  ret 4
LoopJmpZxSub endp
LoopJmpZxSub_endp:

LoopJmpLingo_proc:
align		16
LoopLingo:
	add	eax, 1
	mov	cl,	ch
	add	cl,	[eax]
	je		LoopLingo
	add	cl,	10h
	jle		LoopLingo
	jmp	edx
align		16
LoopJmpLingo 	proc
	pop	edx
	mov	ecx,	0D0D0h
	pop	eax
	add	cl,	[eax]
	je		LoopLingo
	add	cl,	10h
	jle		LoopLingo
	jmp	edx
LoopJmpLingo 	endp
LoopJmpLingo_endp:

ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]


